( function( $ ) {

	function _equal_height( slider_wrapper ) {

		var post_wrapper = slider_wrapper.find('.uael-post-wrapper'),
            post_active = slider_wrapper.find('.slick-active'),
            max_height = -1,
            wrapper_height = -1,
            equal_height = slider_wrapper.data( 'equal-height' );

        if ( 'yes' != equal_height ) {
        	return;
        }

        post_active.each( function( i ) {

            var this_height = $( this ).outerHeight(),
                blog_post = $( this ).find( '.uael-post__inner-wrap' ),
                blog_post_height = blog_post.outerHeight();

            if( max_height < blog_post_height ) {
                max_height = blog_post_height;
            }

            if ( wrapper_height < this_height ) {
                wrapper_height = this_height
            }
        });

        post_active.each( function( i ) {
            var selector = $( this ).find( '.uael-post__bg-wrap' );
            selector.animate({ height: max_height }, { duration: 200, easing: 'linear' });
        });

        slider_wrapper.find('.slick-list.draggable').animate({ height: max_height }, { duration: 200, easing: 'linear' });

        max_height = -1;
        wrapper_height = -1;

        post_wrapper.each(function() {

            var $this = jQuery( this ),
                selector = $this.find( '.uael-post__bg-wrap' ),
                blog_post = $this.find( '.uael-post__inner-wrap' ),
                blog_post_height = blog_post.outerHeight();

            if ( $this.hasClass('slick-active') ) {
                return true;
            }

            selector.css( 'height', blog_post_height );
        });

	}

	var WidgetUAELPostGridHandler = function( $scope, $ ) {

		if ( 'undefined' == typeof $scope ) {
			return;
		}

		var selector = $scope.find( '.uael-post-grid__inner' );

		if ( selector.length < 1 ) {
			return;
		}

		var layout = $scope.find( '.uael-post-grid' ).data( 'layout' ),
			structure = $scope.find( '.uael-post-grid' ).data( 'structure' );

		if (
			( 'normal' == structure || 'masonry' == structure ) &&
			'' != layout
		) {

			$scope.imagesLoaded( function(e) {

				selector.isotope({
					layoutMode: layout,
					itemSelector: '.uael-post-wrapper',
				});
			});
		}

		$scope.find( '.uael-post__header-filter' ).off( 'click' ).on( 'click', function() {

			$( this ).siblings().removeClass( 'uael-filter__current' );
			$( this ).addClass( 'uael-filter__current' );

			_uaelPostAjax( $scope, $( this ) );

		});

		if ( 'carousel' == structure ) {

			var slider_wrapper 	= $scope.find( '.uael-post-grid' ),
				slider_selector = slider_wrapper.find( '.uael-post-grid__inner' ),
				slider_options 	= slider_wrapper.data( 'post_slider' );

			$scope.imagesLoaded( function() {

				slider_selector.slick( slider_options );
				_equal_height( slider_wrapper );
			});

			slider_wrapper.on( 'afterChange', function() {
				_equal_height( slider_wrapper );
			} );


			$( window ).resize(function() {
				$( "#log" ).append( "<div>Handler for .resize() called.</div>" );
			});
		}

		if ( selector.hasClass( 'uael-post-infinite-scroll' ) ) {

			selector.infinitescroll(
				{
	                navSelector     : '.uael-grid-pagination',
	                nextSelector    : '.uael-grid-pagination a.next',
	                itemSelector    : '.uael-post-wrapper',
	                prefill         : true,
	                bufferPx        : 200,
	                loading         : {
						msgText         : 'Loading',
						finishedMsg     : '',
						img             : uael_script.post_loader,
						speed           : 10,
	                }
	            },
	            function( elements ) {

		            elements = $( elements );

		            var skin = $scope.find( '.uael-post-grid' ).data( 'skin' );

		            elements.each( function ( value, key ) {

		            	if ( $( this ).hasClass( 'uael-post-wrapper-featured' ) ) {
		            		$( this ).removeClass( 'uael-post-wrapper-featured' );
		            	}
		            } );

		            if (
						( 'normal' == structure || 'masonry' == structure ) &&
						'' != layout
					) {

		            	selector.isotope()
		            	.append( elements )
						.isotope( 'appended', elements )
						.isotope( 'layout' );

		                selector.find( '.uael-post-wrapper' ).resize( function() {
							selector.isotope( 'layout' );
						});
		            }
		        }
	        );
		}

	}

	$( 'body' ).delegate( '.uael-grid-pagination .page-numbers', 'click', function( e ) {

		e.preventDefault();

		$scope = $( this ).closest( '.elementor-widget-uael-posts' );

		$scope.find( '.uael-post-grid .uael-post-wrapper' ).last().after( '<div class="uael-post-loader"><div class="uael-loader"></div><div class="uael-loader-overlay"></div></div>' );

		var page_id = $scope.find( '.uael-post-grid' ).data('page');
		var page_number = 1;
		var curr = parseInt( $scope.find( '.uael-grid-pagination .page-numbers.current' ).html() );
		var skin = $scope.find( '.uael-post-grid' ).data( 'skin' );

		if ( $( this ).hasClass( 'next' ) ) {
			page_number = curr + 1;
		} else if ( $( this ).hasClass( 'prev' ) ) {
			page_number = curr - 1;
		} else {
			page_number = $( this ).html();
		}

		$.ajax({
			url: uael.ajax_url,
			data: {
				action: 'uael_get_post',
				page_id : page_id,
				widget_id: $scope.data( 'id' ),
				category: $scope.find( '.uael-filter__current' ).data( 'filter' ),
				skin: skin,
				page_number : page_number
			},
			dataType: 'json',
			type: 'POST',
			success: function ( data ) {

				$scope.find( '.uael-post-loader' ).remove();

				var sel = $scope.find( '.uael-post-grid__inner' );

				if( 'news' == skin ) {
					sel = $scope.find( '.uael-post-grid' );
				}

				sel.html( data.data.html );

				$scope.find( '.uael-post__footer' ).html( data.data.pagination );

				var layout = $scope.find( '.uael-post-grid' ).data( 'layout' ),
					structure = $scope.find( '.uael-post-grid' ).data( 'structure' );
					selector = $scope.find( '.uael-post-grid__inner' );

				if (
					( 'normal' == structure || 'masonry' == structure ) &&
					'' != layout
				) {
					$scope.imagesLoaded( function() {

						selector.isotope( 'destroy' );
						selector.isotope({
							layoutMode: layout,
							itemSelector: '.uael-post-wrapper',
						});
					});
				}
			}
		});

	} );

	var _uaelPostAjax = function( $scope, $this ) {

		var page_id = $scope.find( '.uael-post-grid' ).data('page');

		$scope.find( '.uael-post-grid .uael-post-wrapper' ).last().after( '<div class="uael-post-loader"><div class="uael-loader"></div><div class="uael-loader-overlay"></div></div>' );

		$.ajax({
			url: uael.ajax_url,
			data: {
				action: 'uael_get_post',
				page_id : page_id,
				widget_id: $scope.data( 'id' ),
				category: $this.data( 'filter' ),
				skin: $scope.find( '.uael-post-grid' ).data( 'skin' ),
				page_number : ''
			},
			dataType: 'json',
			type: 'POST',
			success: function ( data ) {

				$scope.find( '.uael-post-loader' ).remove();
				$scope.find( '.uael-post-grid__inner' ).html( data.data.html );
				$scope.find( '.uael-post__footer' ).html( data.data.pagination );

				var layout = $scope.find( '.uael-post-grid' ).data( 'layout' ),
					structure = $scope.find( '.uael-post-grid' ).data( 'structure' );
					selector = $scope.find( '.uael-post-grid__inner' );

				if (
					( 'normal' == structure || 'masonry' == structure ) &&
					'' != layout
				) {

					$scope.imagesLoaded( function() {
						selector.isotope( 'destroy' );
						selector.isotope({
							layoutMode: layout,
							itemSelector: '.uael-post-wrapper',
						});
					});
				}
			}
		});
	}

	$( window ).on( 'elementor/frontend/init', function () {

		elementorFrontend.hooks.addAction( 'frontend/element_ready/uael-posts.classic', WidgetUAELPostGridHandler );

		elementorFrontend.hooks.addAction( 'frontend/element_ready/uael-posts.event', WidgetUAELPostGridHandler );

		elementorFrontend.hooks.addAction( 'frontend/element_ready/uael-posts.card', WidgetUAELPostGridHandler );

		elementorFrontend.hooks.addAction( 'frontend/element_ready/uael-posts.feed', WidgetUAELPostGridHandler );

		elementorFrontend.hooks.addAction( 'frontend/element_ready/uael-posts.news', WidgetUAELPostGridHandler );

	});

} )( jQuery );
